<?xml version="1.0" encoding="UTF-8"?>
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:xfm="http://www.w3.org/2002/xforms" xmlns:xlink="http://www.w3.org/1999/xlink " xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:my="http://commerce.example.com/payment" xmlns:ev="http://www.w3.org/2001/xml-events" xml:lang="en">
	<head>
		<!--
		<link rel="stylesheet" type="text/css" href="bookmarks.css" />-->
		<style type="text/css">
			input.linkinput::value {width: 200px;background-color:#eeeeee;}
			input.hrefinput::value {width: 280px;background-color:#eeeeee;}
			/*input.linkinput label {caption-side:right;}*/
			input.section::value {font-size: 20px;width: 500px;background-color:#eeeeee;display:block!important;}
			input.section label {background-color:blue;color:white;width:500px;display:block!important;}
                        /* the new CSS renderer understands setting these to inline */
                  input, input::value, input > label,trigger.go ,trigger.go::value {display:inline!important;}
			p.link {margin-top:1px;margin-bottom:1px;padding-left:20px;}
			p.section {margin: 5px; border-style:solid; border-width:2px;background-color:#eeeeee;padding-left:20px;padding-top:8px;}
			div.main {margin-left: 20px;}
			submit {color:red;font-weight:bold;}
			trigger.go {font-size:7pt;}
			trigger.go::value {font-size:7pt;}
                        .buttonrow > trigger, .buttonrow >trigger::value {display:inline!important;}
            *::repeat-index input::value {background-color:#ddddff!important;}
			div.mainscroll {overflow:scroll;width:600px;height:500px;}
		</style>
		<title>Editing Hierarchical Bookmarks Using In An XML Browser</title>
		<xfm:model id="bookmarks">
			<xfm:submission id="submit1" method="put" action="bookmarks2.xml" replace="none"/>
			<xfm:schema />
			<xfm:instance src="bookmarks2.xml" />
		</xfm:model>
	</head>
	<body>
		<div class="main">
			<h1>Edit Bookmarks</h1>
            <div class="mainscroll">
			<xfm:repeat ref="/bookmarks/section" id="repeatSections">
				<p class="section">
					<xfm:input ref="@name" class="section">
						<xfm:label class="section">Section</xfm:label>
					</xfm:input>
					<!-- BOOKMARK REPEAT START -->
					
					<xfm:repeat ref="bookmark" id="repeatBookmarks">
						<p class="link">
							<xfm:input ref="@name" class="linkinput">
								<xfm:label></xfm:label>
							</xfm:input>
							<xfm:input ref="@href" class="hrefinput">
								<xfm:label></xfm:label>
							</xfm:input>
							<xfm:trigger class="go">
								<xfm:label style="display:none!important;">GO</xfm:label>
								<xfm:load ev:event="DOMActivate" ref="@href" show="new"/>
							</xfm:trigger>
						</p>
					</xfm:repeat>
					<!-- INSERT BOOKMARK BUTTON -->
					<p class="buttonrow">
                                        
						<xfm:trigger id="insertbutton">
							<xfm:label>Insert before</xfm:label>
							<xfm:action ev:event="DOMActivate">
							<xfm:insert nodeset="/bookmarks/section[index('repeatSections')]/bookmark" at="index('repeatBookmarks')" position="before"  />
							<xfm:setvalue ref="/bookmarks/section[index('repeatSections')]/bookmark[index('repeatBookmarks')]/@href">http://</xfm:setvalue>
							</xfm:action>
						</xfm:trigger>
						<xfm:trigger id="insertafterbutton">
							<xfm:label>Insert after</xfm:label>
							<xfm:action ev:event="DOMActivate">
								<xfm:insert nodeset="/bookmarks/section[index('repeatSections')]/bookmark" at="index('repeatBookmarks')" position="after"  />
							<xfm:setvalue ref="/bookmarks/section[index('repeatSections')]/bookmark[index('repeatBookmarks')]/@href">http://</xfm:setvalue>
							</xfm:action>
						</xfm:trigger>
						<!-- DELETE BOOKMARK BUTTON -->
						<xfm:trigger id="delete">
							<xfm:label>Delete bookmark</xfm:label>
							<xfm:delete nodeset="/bookmarks/section[index('repeatSections')]/bookmark" at="index('repeatBookmarks')" ev:event="xforms-activate" />
						</xfm:trigger>
                                                
                                                </p>
                                                <p>
						<!-- SUBMIT BUTTON -->
                        <!--
						<xfm:submit class="inline" name="Submit" submission="submit1">
							<xfm:hint>Click to submit</xfm:hint>
							<xfm:label>Save</xfm:label>
						</xfm:submit>
                        -->
					</p>
				</p>
			</xfm:repeat>
            </div> <!-- scrollable div-->

			<p>
				<!-- INSERT SECTION BUTTON -->
				<xfm:trigger id="insertsectionbutton">
					<xfm:label>Insert section</xfm:label>
					<xfm:insert ref="/bookmarks/section" at="index('repeatSections')" position="after" ev:event="click" />
				</xfm:trigger>
				<!-- DELETE SECTION BUTTON -->
				<xfm:trigger id="deletesectionbutton">
					<xfm:label>Delete section</xfm:label>
					<xfm:delete ref="/bookmarks/section" at="index('repeatSections')" ev:event="click" />
				</xfm:trigger>
				<!-- SUBMIT BUTTON -->
				<xfm:submit name="Submit" submission="submit1">
					<xfm:hint>Click to submit</xfm:hint>
					<xfm:label>Save</xfm:label>
				</xfm:submit>
			</p>
		</div>
	</body>
</html>
